# SshTask

Extends \Task

Execute commands on a remote host using ssh.

Use \Project#createTask to register a new Task.

author | Johan Van den Brande johan@vandenbrande.com
version | $Id: fcc9b201c6ff1159698d67f5966f6dd39c7591c7 $
package | phing.tasks.ext

### Methods

## Creates an Ssh2MethodParam object. Handles the <sshconfig /> nested tag

    createSshconfig() : \Ssh2MethodParam

### Response

`\Ssh2MethodParam`

## getCommand

    getCommand() : string

### Response

`string`

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## getHost

    getHost() : string

### Response

`string`

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## getPassword

    getPassword() : string

### Response

`string`

## getPort

    getPort() : integer

### Response

`integer`

## Returns the private keyfile

    getPrivkeyfile()

## Returns the private keyfile passphrase

    getPrivkeyfilepassphrase( $privkeyfilepassphrase) : string

### Arguments

#### $privkeyfilepassphrase

``

### Response

`string`

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## getPty

    getPty() : string

### Response

`string`

## Returns the pubkeyfile

    getPubkeyfile()

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## getUsername

    getUsername() : string

### Response

`string`

## This function reads the streams from the ssh2_exec command, stores output data, checks for errors and closes the streams properly.

    handleStream( $stream)

throws |

### Arguments

#### $stream

``

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## setCommand

    setCommand( $command)

### Arguments

#### $command

``

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Sets whether to display the output of the command

    setDisplay(boolean $display)

### Arguments

#### $display

`boolean`

## setHost

    setHost( $host)

### Arguments

#### $host

``

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## setPassword

    setPassword( $password)

### Arguments

#### $password

``

## setPort

    setPort( $port)

### Arguments

#### $port

``

## Sets the private key file of the user to scp

    setPrivkeyfile( $privkeyfile)

### Arguments

#### $privkeyfile

``

## Sets the private key file passphrase of the user to scp

    setPrivkeyfilepassphrase( $privkeyfilepassphrase)

### Arguments

#### $privkeyfilepassphrase

``

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the name of the property to capture (any) output of the command

    setProperty(string $property)

### Arguments

#### $property

`string`

## setPty

    setPty( $pty)

### Arguments

#### $pty

``

## Sets the public key file of the user to scp

    setPubkeyfile( $pubkeyfile)

### Arguments

#### $pubkeyfile

``

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Initiates a ssh connection and stores it in $this->connection

    setupConnection()

## setUsername

    setUsername( $username)

### Arguments

#### $username

``

### Properties

## host

    host :

### Type(s)

``

## port

    port :

### Type(s)

``

## methods

    methods :

### Type(s)

``

## username

    username :

### Type(s)

``

## password

    password :

### Type(s)

``

## command

    command :

### Type(s)

``

## pubkeyfile

    pubkeyfile :

### Type(s)

``

## privkeyfile

    privkeyfile :

### Type(s)

``

## privkeyfilepassphrase

    privkeyfilepassphrase :

### Type(s)

``

## pty

    pty :

### Type(s)

``

## failonerror

    failonerror :

### Type(s)

``

## The name of the property to capture (any) output of the command

    property : string

var |

### Type(s)

`string`

## Whether to display the output of the command

    display : boolean

var |

### Type(s)

`boolean`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`